Bug 782970 - rpmbuild processes %include directive even if inside non-matching %if
Summary: rpmbuild processes %include directive even if inside non-matching %if
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: rpm
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Panu Matilainen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 920190
TreeView+ depends on / blocked
 
Reported: 2012-01-19 00:17 UTC by Mikhail T.
Modified: 2013-03-11 14:22 UTC (History)
3 users (show)

Fixed In Version: rpm-4.9.1.2-6.fc16
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 801427 801429 920190 (view as bug list)
Environment:
Last Closed: 2012-03-11 23:22:04 UTC


Attachments (Terms of Use)
Sample spec demonstrating the bug (146 bytes, text/plain)
2012-01-19 00:17 UTC, Mikhail T.
no flags Details

Description Mikhail T. 2012-01-19 00:17:17 UTC
Created attachment 556142 [details]
Sample spec demonstrating the bug

Description of problem:

It appears, that the %include directives are processes at all times -- even if they are inside unmatching %ifos.

Version-Release number of selected component (if applicable):

rpmbuild --version
RPM version 4.4.2.3

How reproducible:
Always

Steps to Reproduce:
1. Attempt `rpmbuild -bb test.spec' using the attached sample spec-file on any OS.
  
Actual results:

error: Unable to open no-such-file.inc: No such file or directory
error: Package has no %description: foo

Expected results:
Some other error -- the `no-such-file.inc' should not be mentioned.

Comment 1 Panu Matilainen 2012-02-28 10:21:54 UTC
> rpmbuild --version
> RPM version 4.4.2.3

Generally speaking you should test with the version you're reporting a bug for, Fedora rawhide has rpm 4.9.x, not the rather ancient 4.4.x.  Doesn't matter in this case though, the bug is probably as old as support for %include itself...
Fixed upstream now, leaving this open for Fedora tracking.

Comment 2 Fedora Update System 2012-03-07 11:34:32 UTC
rpm-4.9.1.2-14.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/rpm-4.9.1.2-14.fc17

Comment 3 Fedora Update System 2012-03-07 11:37:04 UTC
rpm-4.9.1.2-6.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/rpm-4.9.1.2-6.fc16

Comment 4 Mikhail T. 2012-03-07 18:06:34 UTC
Thanks, all. Any chance to see the fix in RedHat as well? We are using 5.6 Tikanga here...

Comment 5 Fedora Update System 2012-03-08 04:59:11 UTC
Package rpm-4.9.1.2-6.fc16:
* should fix your issue,
* was pushed to the Fedora 16 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing rpm-4.9.1.2-6.fc16'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-3336/rpm-4.9.1.2-6.fc16
then log in and leave karma (feedback).

Comment 6 Panu Matilainen 2012-03-08 07:37:14 UTC
(In reply to comment #4)
> Thanks, all. Any chance to see the fix in RedHat as well? We are using 5.6
> Tikanga here...

You'll need to file separate bug(s) for the affected products (for practical purposes that'd be RHEL 5 and 6) if you want to try to get this fixed in existing RHEL versions as well.

Comment 7 Mikhail T. 2012-03-08 13:56:14 UTC
Changing the affected "Product" to RHEL5.

Comment 8 Panu Matilainen 2012-03-08 13:59:56 UTC
Don't do that. File a new bug(s) or clone this one but you can't reuse the same bug for something with an entirely different process of handling these things. Changing back to Fedora.

Comment 9 Mikhail T. 2012-03-08 14:07:19 UTC
Panu, I'm rather disappointed, that RedHat is making paying customers jump through such hoops to get a bug fixed in the production version of the flagship product.

Sheer appreciation for my diagnosing the bug, bothering to file it, and patiently waiting for resolution should've lead you to taking care of the necessary "process" yourself.

Nevertheless, I will try to follow your instructions, but do note, that you've just added one more reason for us to abandon RHEL in favor of Fedora.

Comment 10 Panu Matilainen 2012-03-08 14:52:02 UTC
As a paying customer, you should be using the official RHEL support channels to get priorized as one and to have the process taken care of for you. Bugzilla is merely a bug tracking mechanism (which gets reports from people running clones and whatnot) and nothing more, and engineers like me looking at bugzilla have no way of knowing who's a customer and who's not when it's not coming through the official channels.

Also please realize there's no automatic connection between bugs filed against any given Fedora version or component to corresponding RHEL component - bug fixes for RHEL are much more selectively applied than for Fedora to minimize risk of regressions, the versions between the two often are radically different, the maintainer can and often does differ between the two etc.

In any case, thanks for reporting the long-standing bug.

Comment 11 Mikhail T. 2012-03-08 15:12:46 UTC
> no way of knowing who's a customer and who's not

Why would a non-customer care about RHEL at all?..

Comment 12 Fedora Update System 2012-03-11 23:22:04 UTC
rpm-4.9.1.2-6.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2012-03-21 19:06:12 UTC
rpm-4.9.1.2-14.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.